1. 两个数组的交集 II

image-20200713200853665
思路一:
  1. 使用 HashMapnums1 中的元素加入到 map 中并统计所有数字出现的次数
  2. 遍历 nums2,若 nums2 中的元素在 map 中有,则将该元素加入到结果集中并且将 map 中该元素出现的次数减一
  3. 返回结果集
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
class Solution {
public int[] intersect(int[] nums1, int[] nums2) {
// 提高效率,遍历较小的数组,将其元素加入到 map 中
if (nums1.length > nums2.length) {
return intersect(nums2,nums1);
}
Map<Integer, Integer> map = new HashMap<>();
for (int num: nums1) {
int count = map.getOrDefault(num, 0) + 1;
map.put(num, count);
}
int[] res = new int[nums1.length];
int index = 0;
for (int num: nums2) {
int count = map.getOrDefault(num, 0);
if (count > 0) {
res[index++] = num;
count--;
if (count > 0) {
map.put(num, count);
} else {
map.remove(num);
}
}
}
return Arrays.copyOfRange(res, 0, index);
}
}
思路二:

如果两个数组是有序的,则可以便捷地计算两个数组的交集。

首先对两个数组进行排序,然后使用两个指针遍历两个数组。

初始时,两个指针分别指向两个数组的头部。每次比较两个指针指向的两个数组中的数字,如果两个数字不相等,则将指向较小数字的指针右移一位,如果两个数字相等,将该数字添加到答案,并将两个指针都右移一位。当至少有一个指针超出数组范围时,遍历结束。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
class Solution {
public int[] intersect(int[] nums1, int[] nums2) {
Arrays.sort(nums1);
Arrays.sort(nums2);
int length1 = nums1.length, length2 = nums2.length;
int[] intersection = new int[Math.min(length1, length2)];
int index1 = 0, index2 = 0, index = 0;
while (index1 < length1 && index2 < length2) {
if (nums1[index1] < nums2[index2]) {
index1++;
} else if (nums1[index1] > nums2[index2]) {
index2++;
} else {
intersection[index] = nums1[index1];
index1++;
index2++;
index++;
}
}
return Arrays.copyOfRange(intersection, 0, index);
}
}

/*
作者:LeetCode-Solution
链接:https://leetcode-cn.com/problems/intersection-of-two-arrays-ii/solution/liang-ge-shu-zu-de-jiao-ji-ii-by-leetcode-solution/
来源:力扣(LeetCode)
著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。
*/

2. 二叉树的最小深度

image-20200713203100463
解题思路:

使用递归,思路与求二叉树最大深度相似。

代码实现:
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
/**
* Definition for a binary tree node.
* public class TreeNode {
* int val;
* TreeNode left;
* TreeNode right;
* TreeNode(int x) { val = x; }
* }
*/
class Solution {
public int minDepth(TreeNode root) {
if (root == null) return 0;
if (root.left == null && root.right == null) return 1;
if (root.left == null) return minDepth(root.right) + 1;
if (root.right == null) return minDepth(root.left) + 1;
return Math.min(minDepth(root.left), minDepth(root.right)) + 1;
}
}

3. 杨辉三角

image-20200713205033766
解题思路:

每一行都基于前一行构造,顺的写即可

代码实现:
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
class Solution {
public List<List<Integer>> generate(int numRows) {
List<List<Integer>> triangle = new ArrayList<List<Integer>>();

// First base case; if user requests zero rows, they get zero rows.
if (numRows == 0) {
return triangle;
}

// Second base case; first row is always [1].
triangle.add(new ArrayList<>());
triangle.get(0).add(1);

for (int rowNum = 1; rowNum < numRows; rowNum++) {
List<Integer> row = new ArrayList<>();
List<Integer> prevRow = triangle.get(rowNum-1);

// The first row element is always 1.
row.add(1);

// Each triangle element (other than the first and last of each row)
// is equal to the sum of the elements above-and-to-the-left and
// above-and-to-the-right.
for (int j = 1; j < rowNum; j++) {
row.add(prevRow.get(j-1) + prevRow.get(j));
}

// The last row element is always 1.
row.add(1);

triangle.add(row);
}

return triangle;
}
}

/*
作者:LeetCode
链接:https://leetcode-cn.com/problems/pascals-triangle/solution/yang-hui-san-jiao-by-leetcode/
来源:力扣(LeetCode)
著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。
*/

4. 买卖股票的最佳时机

image-20200718150149049
解题方法一:暴力枚举法

使用 嵌套循环遍历数组,列出所有可能的收益,从中找到最大的作为结果返回

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
public class Solution {

public int maxProfit(int[] prices) {
int len = prices.length;
if (len < 2) {
return 0;
}

// 有可能不做交易,因此结果的初始值设置为 0
int res = 0;
for (int i = 0; i < len - 1; i++) {
for (int j = i + 1; j < len; j++) {
res = Math.max(res, prices[j] - prices[i]);
}
}
return res;
}
}

/*
作者:liweiwei1419
链接:https://leetcode-cn.com/problems/best-time-to-buy-and-sell-stock/solution/bao-li-mei-ju-dong-tai-gui-hua-chai-fen-si-xiang-b/
来源:力扣(LeetCode)
著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。
*/
解题方法二:暴力算法的优化

只需要关心之前看到的最低价格,用一个变量记录下之前的最低价格,这样可以省去内层循环

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
public class Solution {

public int maxProfit(int[] prices) {
int len = prices.length;
if (len < 2) {
return 0;
}

int res = 0;

// 表示在当前位置之前的最小值,假设修正法(打擂台法)
int minVal = prices[0];
// 注意:这里从 1 开始
for (int i = 1; i < len; i++) {
res = Math.max(res, prices[i] - minVal);
minVal = Math.min(minVal, prices[i]);
}
return res;
}
}

/*
作者:liweiwei1419
链接:https://leetcode-cn.com/problems/best-time-to-buy-and-sell-stock/solution/bao-li-mei-ju-dong-tai-gui-hua-chai-fen-si-xiang-b/
来源:力扣(LeetCode)
著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。
*/

5. 环形链表

image-20200718152847322
解体方法一:哈希表

我们使用 HashSet 来存储每个访问过的节点的引用,如果该节点出现在 HashSet 中,则说明链表为环形链表。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
/**
* Definition for singly-linked list.
* class ListNode {
* int val;
* ListNode next;
* ListNode(int x) {
* val = x;
* next = null;
* }
* }
*/
public boolean hasCycle(ListNode head) {
Set<ListNode> nodesSeen = new HashSet<>();
while (head != null) {
if (nodesSeen.contains(head)) {
return true;
} else {
nodesSeen.add(head);
}
head = head.next;
}
return false;
}

/*
作者:LeetCode
链接:https://leetcode-cn.com/problems/linked-list-cycle/solution/huan-xing-lian-biao-by-leetcode/
来源:力扣(LeetCode)
著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。
*/
解题方法二:快慢指针

想象两个人跑圈子,如果一个人较快一个人较慢,则这两个人迟早会相遇

我们用快慢指针来代表这两个人,快指针每次后移两步,慢指针每次后移一步,如果两个指针相遇,则说明链表为环形链表

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
/**
* Definition for singly-linked list.
* class ListNode {
* int val;
* ListNode next;
* ListNode(int x) {
* val = x;
* next = null;
* }
* }
*/
public boolean hasCycle(ListNode head) {
if (head == null || head.next == null) {
return false;
}
ListNode slow = head;
ListNode fast = head.next;
while (slow != fast) {
if (fast == null || fast.next == null) {
return false;
}
slow = slow.next;
fast = fast.next.next;
}
return true;
}

/*
作者:LeetCode
链接:https://leetcode-cn.com/problems/linked-list-cycle/solution/huan-xing-lian-biao-by-leetcode/
来源:力扣(LeetCode)
著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。
*/

6. 最小栈

image-20200718162438484
解法一:

更改底层数据结构,设计一个 MinStackNode 类,类中每个节点用来存放值和当前栈中的最小值。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
class MinStack {
LinkedList<MinStackNode> stack;

/**
* initialize your data structure here.
*/
public MinStack() {
stack = new LinkedList<>();
}

public void push(int x) {
if (stack.size() > 0) {
int preMin = stack.getLast().min;
int min = Math.min(x, preMin);
stack.add(new MinStackNode(x, min));
} else {
stack.add(new MinStackNode(x, x));
}
}

public void pop() {
stack.removeLast();
}

public int top() {
return stack.getLast().value;
}

public int getMin() {
return stack.getLast().min;
}
}

class MinStackNode {
int value;
int min;

public MinStackNode(int value, int min) {
this.value = value;
this.min = min;
}
}

/**
* Your MinStack object will be instantiated and called as such:
* MinStack obj = new MinStack();
* obj.push(x);
* obj.pop();
* int param_3 = obj.top();
* int param_4 = obj.getMin();
*/
解法二:

设计一个辅助栈,用来保存最小值,如果 pop() 的值刚好是最小值,那么同时将辅助栈的栈顶也 pop()

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
class MinStack {
private Stack<Integer> dataStack;
private Stack<Integer> minStack;

public MinStack() {
dataStack = new Stack<>();
minStack = new Stack<>();
}

public void push(int x) {
// 先将 x 压入数据栈
dataStack.push(x);
// 如果 x 是当前的最小值,则也需要将 x 压入辅助栈
if (minStack.isEmpty() || x <= minStack.peek()) {
minStack.push(x);
}
}

public void pop() {
// 先删除数据栈的栈顶元素 x
int x = dataStack.pop();
// 若 x 是当前的最小值,则也需要删除辅助栈的栈顶元素
if (x == minStack.peek()) {
minStack.pop();
}
}

public int top() {
return dataStack.peek();
}

public int getMin() {
return minStack.peek();
}
}

/*
作者:sweetiee
链接:https://leetcode-cn.com/problems/min-stack/solution/3-chong-fang-fa-shi-xian-bi-xu-miao-dong-by-sweeti/
来源:力扣(LeetCode)
著作权归作者所有。商业转载请联系作者获得授权,非商业转载请注明出处。
*/